unit unidad_ppal;

{$mode objfpc}{$H+}
{$ASSERTIONS ON}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

  { TAlmacenar }

  TAlmacenar = class(TObject)
    FDatos: string;
    property Datos: string read FDatos write FDatos;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure ModificarAlmacen(AAlmacenar: TAlmacenar; const s: string);
begin
  Assert(AAlmacenar <> Nil, 'Cadena no asignada.');
  AAlmacenar.Datos := s;
  ShowMessage(  AAlmacenar.Datos );
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Almacenar: TAlmacenar;
begin
  Almacenar := TAlmacenar.Create;
  try
    ModificarAlmacen(Almacenar, 'Hola, mundo');
  finally
    Almacenar.Free;
  end;

  // Esta llamada fallará y lanzará una excepción
  ModificarAlmacen(Nil, 'Falla');

end;

end.

